#include <iostream>
#include <map>

#define MAXN 1000200

using namespace std;

int main() {
    int pdiv[MAXN], semihp_nums[MAXN], facts[5];
    for (int i = 0; i < MAXN; ++i) pdiv[i] = i;

    semihp_nums[1] = 0;
    for (int i = 5; i < MAXN; i += 4) {
        if (pdiv[i] == i)
            for (int j = 5*i; j < MAXN; j += 4*i)
                pdiv[j] = i;
        semihp_nums[i] = semihp_nums[i-4];
        if (i != pdiv[i] && pdiv[i/pdiv[i]] == i/pdiv[i]) ++semihp_nums[i];
    }

    int n;
    while ((cin >> n) && n) cout << n << ' ' << semihp_nums[n] << endl;

    return 0;
}
