#include <iostream>
#include <complex>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

typedef complex<double> point;

int main() {
    int n;
    double target;

    cin >> n;
    vector<point> v(n);
    double mx = 500, my = 500;
    for (auto& p : v) {
        double x, y;
        cin >> x >> y;
        mx = min(x, mx);
        my = min(y, my);
        p = point(x, y);
    }
    cin >> target;
    point mins(mx, my);
    for (auto& p : v) p -= mins;

    double area = 0;
    for (int i = 0, j = n-1; i < n; j = i++)
        area += imag(v[i]*conj(v[j]))*0.5;

    double scale = sqrt(target/area);

    // cout << area << ' ' << target << ' ' << scale << endl;

    for (auto p : v) cout << real(p*scale) << ' ' << imag(p*scale) << endl;

    return 0;
}
